(*
  OCaml Bindings to the library Fam.

  Copyright (C) 2008  Florent Monnier
  Contact:  <fmonnier@linux-nantes.org>

  This program is free software: you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation, either version 3
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>
*)

type famConnection
external famOpen: unit -> famConnection = "ml_famopen"
external famClose: fc:famConnection -> unit = "ml_famclose"
type famRequest
external famMonitorDirectory: fc:famConnection -> filename:string -> famRequest = "ml_fammonitordirectory"
external famMonitorFile: fc:famConnection -> filename:string -> famRequest = "ml_fammonitorfile"
external famPending: fc:famConnection -> int = "ml_fampending"
type __famEvent
external famNextEvent: fc:famConnection -> __famEvent = "ml_famnextevent"
type famCode =
  | FAMChanged
  | FAMDeleted
  | FAMStartExecuting
  | FAMStopExecuting
  | FAMCreated
  | FAMMoved
  | FAMAcknowledge
  | FAMExists
  | FAMEndExist
external string_of_famCode: code:famCode -> string = "famcode_to_string"
type famEvent = { code: famCode; filename: string }
external _famNextEvent: fc:famConnection -> __famEvent = "ml_famnextevent"
external famEvent_code: fe:__famEvent -> famCode = "famevent_code"
external famEvent_filename: fe:__famEvent -> string = "famevent_filename"
let famNextEvent ~fc =
  let fe = _famNextEvent ~fc in
  { code     = famEvent_code ~fe;
    filename = famEvent_filename ~fe }
;;

