open Fam

let () =
  let fc = famOpen()
  and filename = Sys.argv.(1)
  in
  let _ = famMonitorFile ~fc ~filename in

  Printf.printf "Monitoring File '%s' with fam\n%!" filename;
  print_endline "Exit with Ctrl+C";

  Sys.catch_break true;
  try
    while true do
      let n = famPending ~fc in
      if n > 0 then
        for i=0 to pred n do
          let fe = famNextEvent ~fc in
          Printf.printf "%s file(%s)\n%!"
                          (string_of_famCode fe.code)
                          fe.filename;
        done;
    done;
  with Sys.Break ->
    famClose ~fc;
;;

