(*
  Basic bindings of the libfam for OCaml.

  Copyright (C) 2008  Florent Monnier
  Contact:  <fmonnier@linux-nantes.org>

  This program is free software: you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation, either version 3
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>
*)

(** Binding to the lib-fam *)

(** For documentation read comments in /usr/include/fam.h *)

type famConnection
external famOpen: unit -> famConnection = "ml_famopen"
external famOpen2: appName:string -> famConnection = "ml_famopen2"
external famClose: fc:famConnection -> unit = "ml_famclose"
type famRequest
external new_famRequest: unit -> famRequest = "alloc_famrequest"
external free_famRequest: fr:famRequest -> unit = "free_famrequest"
external famMonitorDirectory: fc:famConnection -> dir:string -> fr:famRequest -> data:'a -> unit = "ml_fammonitordirectory"
external famMonitorFile: fc:famConnection -> file:string -> fr:famRequest -> data:'a -> unit = "ml_fammonitorfile"
external famSuspendMonitor: fc:famConnection -> fr:famRequest -> unit = "ml_famsuspendmonitor"
external famResumeMonitor: fc:famConnection -> fr:famRequest -> unit = "ml_famresumemonitor"
external famCancelMonitor: fc:famConnection -> fr:famRequest -> unit = "ml_famcancelmonitor"
type famCode =
  | FAMChanged
  | FAMDeleted
  | FAMStartExecuting
  | FAMStopExecuting
  | FAMCreated
  | FAMMoved
  | FAMAcknowledge
  | FAMExists
  | FAMEndExist
external string_of_famCode: code:famCode -> string = "famcode_to_string"
external famPending: fc:famConnection -> int = "ml_fampending"
type famEvent
external new_famEvent: unit -> famEvent = "alloc_famevent"
external free_famEvent: fe:famEvent -> unit = "free_famevent"
external famNextEvent: fc:famConnection -> fe:famEvent -> unit = "ml_famnextevent"
external famEvent_code: fe:famEvent -> famCode = "famevent_code"
external famEvent_filename: fe:famEvent -> string = "famevent_filename"
external famEvent_hostname: fe:famEvent -> string = "famevent_hostname"
external famEvent_connection: fe:famEvent -> famConnection = "famevent_conn"
(* external famEvent_request: fe:famEvent -> famRequest = "famevent_req" (* seems inapropriate *) *)
external famEvent_userdata: fe:famEvent -> 'a = "famevent_userdata"
external famRequest_reqnum: fr:famRequest -> int = "famrequest_reqnum"
external famEvent_request_num: fe:famEvent -> int = "famevent_request_num"

