open Fam

let () =
  let fc = famOpen() in
  let fr = new_famRequest() in
  let file = Sys.argv.(1) in
  famMonitorFile ~fc ~file ~fr ~data:();
  Printf.printf "req num %d\n%!" (famRequest_reqnum ~fr);
  Printf.printf "Monitoring File '%s' with fam\n%!" file;
  print_endline "exit with ctrl+C";
  let fe = new_famEvent() in
  Sys.catch_break true;
  try
    while true do
      let n = famPending ~fc in
      if n > 0 then
        for i=0 to pred n do
          famNextEvent ~fc ~fe;
          let code = famEvent_code ~fe in
          Printf.printf "%s" (string_of_famCode ~code);
          let file = famEvent_filename ~fe
          and host = famEvent_hostname ~fe in
          Printf.printf " file(%s)" file;
          if host <> "" then
            Printf.printf " host(%s)" host;
          Printf.printf "\n%!";
        done;
    done;
  with Sys.Break ->
    free_famRequest ~fr;
    free_famEvent ~fe;
    famClose ~fc;
;;

(* vim: ts=2 sts=2 sw=2 et
 *)
